/***********************************************************************************
                         anselm.ru [2014-08-21] GNU GPL
***********************************************************************************/
#pragma once
#include <pthread.h>
#include <sys/time.h>

class Daemon {
friend void term(int signum);
public:
  Daemon(const char* binfile, const char* conffile = NULL, const char* pidfile = NULL) throw(const char*);
  virtual ~Daemon();
  virtual bool start();
protected:
  static bool alert_sleep(const timeval&);
  static bool alert_wake();
  static bool alert_check();
  
  virtual void childloop();
private:
  const char* APPNAME;
  const char* CONFFILE; 
  const char* PIDFILE;
  static pthread_mutex_t d_alert_mutex;
  static pthread_cond_t  d_alert_cond;
  static bool            d_is_alert;
  
  void childcode();
};
