/***********************************************************************************
                         anselm.ru [2014-08-21] GNU GPL
***********************************************************************************/
#pragma once
#include <stdio.h>
#include <libgen.h> //basename
#include <fstream>
#include <fcntl.h>
#include <unistd.h> //read
#include <syslog.h>


#ifdef DEBUG
#define debug(A) A
#else
#define debug(A)
#endif

static const char* SYSLOGNAME = NULL; 

inline void
warning(const char* format, ...) {
  va_list paramList;
  va_start(paramList, format);
  int len = strlen(format)+1, add = len, i;
  char *s = (char*)malloc(len+=add);
  while ( (i = (vsnprintf(s, len, format, paramList))) == -1 || len<=i ) { //becose exists different agreaments about return
    s = (char*)realloc(s, len+=add);
  }
  va_end(paramList);
  
#ifdef SYSLOG
  openlog(SYSLOGNAME, 0, LOG_USER);
  syslog(LOG_NOTICE, "%s", s);
  closelog();
#else
  printf("%s\n", s);
#endif
  
  free(s);
}


inline void
error(const char* format, ...) {
  int ern = errno;
  
  va_list paramList;
  va_start(paramList, format);
  int len = strlen(format)+1, add = len, i;
  char *s = (char*)malloc(len+=add);
  while ( (i = (vsnprintf(s, len, format, paramList))) == -1 || len<=i ) { //becose exists different agreaments about return
    s = (char*)realloc(s, len+=add);
  }
  va_end(paramList);
    
#ifdef SYSLOG
  openlog(SYSLOGNAME, 0, LOG_USER);
  if(ern==0)
    syslog(LOG_ERR, "error: %s", s);
  else    
    syslog(LOG_ERR, "error %d:%s - %s", ern, strerror(ern), s);
  closelog();
#else  
  if(ern==0)
    fprintf(stderr, "error: %s\n", s);
  else    
    fprintf(stderr, "error %d:%s - %s\n", ern, strerror(ern), s);
#endif

  free(s);
}
